%define anolis_release 2
%define debug_package %{nil}
%global kernel_version %(rpm -qa kernel-devel | sed -e 's/kernel-devel-//g')
%define QAT_release 00004

Summary: QAT package(Library and sample application)
Name: kmod-intel-QAT20
Version: L.0.9.4
Release: %{QAT_release}.%{anolis_release}%{dist}
Group: QAT/Base
License: BSD and (BSD or GPLv2)
Source: %{name}-%{version}-%{QAT_release}.tar.gz
Patch1000: 1000-bugfix-support-5.10.patch

BuildRequires: gcc gcc-c++ make systemd-devel openssl-devel zlib-devel yasm
BuildRequires: libudev-devel >= 1.47
BuildRequires: kernel-devel >= 5.10.112
BuildRequires: kernel-core >= 5.10.112
BuildRequires: boost-devel
Requires: %{name}-driver = %{version}-%{release}
ExclusiveArch: x86_64

%description
Intel(R) QuickAssist Technology user space library and sample application Linux
version %{version}

%package driver
Summary: kernel driver modules

%description driver
Intel(R) QuickAssist Technology Driver for Linux version %{version}

%prep
%setup -c %{name}-%{version} -q
%patch1000 -p1

%build
unset ICP_ROOT ICP_ARCH_USER ICP_BUILDSYSTEM_PATH ICP_BUILD_OUTPUT ICP_ENV_DIR ICP_TOOLS_TARGET
%configure
%make_build
%make_build samples

%pre
groupadd -f qat

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/udev/rules.d
mkdir -p %{buildroot}/%{_libdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}/usr/bin/QAT
mkdir -p %{buildroot}/usr/bin/QAT/build
mkdir -p %{buildroot}/lib/firmware
MODPATH=drivers/crypto/qat
KERNEL_VER=%{kernel_version}
SRCMODDIR=${RPM_BUILD_DIR}/%{name}-%{version}/quickassist/qat/${MODPATH}
DSTMODDIR=%{buildroot}/lib/modules/${KERNEL_VER}/updates/${MODPATH}
mkdir -p %{buildroot}/lib/modules/${KERNEL_VER}/kernel
mkdir -p ${DSTMODDIR}/qat_common/
mkdir -p ${DSTMODDIR}/qat_4xxx/
mkdir -p ${DSTMODDIR}/qat_4xxxvf/
mkdir -p ${DSTMODDIR}/qat_vqat/
/usr/bin/install -D -m 750 quickassist/build_system/build_files/qat_service %{buildroot}/etc/init.d
/usr/bin/install -D -m 664 quickassist/build_system/build_files/qat.service %{buildroot}//usr/bin/QAT/build
/usr/bin/install -D -m 750 build/adf_ctl %{buildroot}%{_sbindir}
/usr/bin/install -D -m 750 build/vqat_ctl %{buildroot}%{_sbindir}
/usr/bin/install -D -m 755 build/cpa_sample_code %{buildroot}/usr/bin
/usr/bin/install -D -m 755 build/libusdm_drv_s.so %{buildroot}/%{_libdir}
/usr/bin/install -D -m 755 build/libqat_s.so %{buildroot}/%{_libdir}
/usr/bin/install -D -m 750 build/qat_4xxx.bin %{buildroot}/lib/firmware
/usr/bin/install -D -m 750 build/qat_4xxx_mmp.bin %{buildroot}/lib/firmware

/usr/bin/install -D -m 666 build/4xxx_template.conf %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/4xxxvf_dev0.conf.vm %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.sym %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.asym %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 666 build/vqat-adi_dev0.conf.dc %{buildroot}/usr/bin/QAT/build
/usr/bin/install -D -m 755 config_vqat.sh %{buildroot}/usr/bin/QAT/
/usr/bin/install -D -m 755 generate_conf_files.sh %{buildroot}/usr/bin/QAT/

/usr/bin/install -D -m 750 build/usdm_drv.ko %{buildroot}/lib/modules/${KERNEL_VER}/kernel/
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_common/intel_qat.ko ${DSTMODDIR}/qat_common/
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_common/qat_vdcm.ko ${DSTMODDIR}/qat_common/
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_4xxx/qat_4xxx.ko ${DSTMODDIR}/qat_4xxx/qat_4xxx.ko
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_4xxxvf/qat_4xxxvf.ko ${DSTMODDIR}/qat_4xxxvf/qat_4xxxvf.ko
/usr/bin/install -D -m 750 ${SRCMODDIR}/qat_vqat/qat_vqat.ko ${DSTMODDIR}/qat_vqat/qat_vqat.ko

%clean
rm -rf $RPM_BUILD_ROOT

%verifyscript

%files
/etc/init.d/qat_service
%{_sbindir}/adf_ctl
%{_sbindir}/vqat_ctl
/usr/bin/cpa_sample_code
/usr/bin/QAT/
%{_libdir}/libusdm_drv_s.so
%{_libdir}/libqat_s.so
/lib/firmware/qat_4xxx.bin
/lib/firmware/qat_4xxx_mmp.bin

%files driver
/lib/modules/%{kernel_version}/kernel/usdm_drv.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_common/intel_qat.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_common/qat_vdcm.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_4xxx/qat_4xxx.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_4xxxvf/qat_4xxxvf.ko
/lib/modules/%{kernel_version}/updates/drivers/crypto/qat/qat_vqat/qat_vqat.ko

%post
MV=/usr/bin/mv
ECHO=/usr/bin/echo
CP=/usr/bin/cp
SLEEP=/usr/bin/sleep
INSTALL=/usr/bin/install
ICP_ROOT=/usr/bin/QAT/
QAT_SERVICE_PATH=/etc/init.d/
HUGE_PAGE_DIR=/dev/hugepages/qat
SYSTEMD_SYSTEM_UNIT_DIR=`pkg-config --variable=systemdsystemunitdir systemd`
SYSTEMD_UNIT_FILE_PATH=${ICP_ROOT}/build
SYSTEMD_UNIT_FILE=qat.service
INTEL_VENDORID="8086"
QAT_4XXX_DEVICE_NUMBER="4940"
QAT_4XXX_DEVICE_NUMBER_VM="4941"
VQAT_DEVICE_NUMBER="0da5"
QAT_4XXX_NUM_VFS=16
DEVICES="${QAT_4XXX_DEVICE_NUMBER} ${QAT_4XXX_DEVICE_NUMBER_VM} ${VQAT_DEVICE_NUMBER}"
num4xxxDevicesP=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_4XXX_DEVICE_NUMBER}"`
num4xxxDevicesV=`lspci -n | egrep -c "${INTEL_VENDORID}:${QAT_4XXX_DEVICE_NUMBER_VM}"`
numVQATDevices=`lspci -n | egrep -c "${INTEL_VENDORID}:${VQAT_DEVICE_NUMBER}"`

if [ -e ${QAT_SERVICE_PATH}/qat_service -a -e "/dev/qat_adf_ctl" ]; then
	until ${QAT_SERVICE_PATH}/qat_service shutdown
	do
		${SLEEP} 1
	done
fi
groupadd -f qat
if [ ! -d /etc/qat_conf_backup ]; then
	mkdir /etc/qat_conf_backup
fi
${MV} /etc/4xxx*.conf /etc/qat_conf_backup/ 2>/dev/null
${MV} /etc/4xxxvf*.conf /etc/qat_conf_backup/ 2>/dev/null
${MV} /etc/vqat*.conf /etc/qat_conf_backup/ 2>/dev/null

if [ "${num4xxxDevicesP}" -gt "0" ];then
	${ICP_ROOT}/generate_conf_files.sh -n ${num4xxxDevicesP} -f ${ICP_ROOT}/build/4xxx_template.conf -o /etc/
	if [ -e "/etc/default/qat" ];then
		. /etc/default/qat
		if [ -n "${SRIOV_ENABLE}" ];then
			if [ "${SRIOV_ENABLE}" -eq "1" ]; then
				num4xxxDevicesV=$((${QAT_4XXX_NUM_VFS} * ${num4xxxDevicesP}))
			fi
		fi
	else
		echo "#Remove comment on next line to enable sriov" > /etc/default/qat
		echo "#SRIOV_ENABLE=1" >> /etc/default/qat
	fi
fi

if [ "${num4xxxDevicesV}" -gt "0" ];then
	for (( dev=0; dev<${num4xxxDevicesV}; dev++ ));do
		${INSTALL} -D -m 640 ${ICP_ROOT}/build/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev${dev}.conf
	done
	echo "SRIOV_ENABLE=1" > /etc/default/qat
fi

if [ "${numVQATDevices}" -gt "0" ];then
	${ICP_ROOT}/config_vqat.sh
	echo "SRIOV_ENABLE=1" > /etc/default/qat
fi

echo 'KERNEL=="qat_adf_ctl" MODE="0660" GROUP="qat"' > /etc/udev/rules.d/00-qat.rules
echo 'KERNEL=="qat_dev_processes" MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
echo 'KERNEL=="usdm_drv" MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/mkdir' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/chgrp qat' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="add", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/chmod 0770' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
echo 'ACTION=="remove", DEVPATH=="/module/usdm_drv" SUBSYSTEM=="module" RUN+="/bin/rmdir' ${HUGE_PAGE_DIR}\" >> /etc/udev/rules.d/00-qat.rules
for dev in $DEVICES; do
	echo 'KERNEL=="uio*", ATTRS{vendor}=="0x'`echo ${INTEL_VENDORID} | tr -d \"`'", ATTRS{device}=="0x'`echo ${dev} | tr -d \"`'"  MODE="0660" GROUP="qat"' >> /etc/udev/rules.d/00-qat.rules
done

if [ -e /usr/bin/systemctl ]; then
	if [ "${SYSTEMD_SYSTEM_UNIT_DIR}" == "" ]; then
		${ECHO} "Could not find path to place systemd unit file. Using /usr/lib/systemd/system by default"
	fi
	${CP} -f ${SYSTEMD_UNIT_FILE_PATH}/${SYSTEMD_UNIT_FILE} ${SYSTEMD_SYSTEM_UNIT_DIR}
	systemctl enable qat
	systemctl daemon-reload
elif [ -e /sbin/chkconfig ] ; then
	chkconfig --add qat_service;
elif [ -e %{_sbindir}/update-rc.d ]; then
	update-rc.d qat_service defaults
fi

${ECHO} "Starting QAT service"
/etc/init.d/qat_service start

%post driver
ECHO=/usr/bin/echo
${ECHO} "Creating module.dep file for QAT released kernel object"
${ECHO} "This will take a few moments";
depmod -a
${ECHO} "%{name}-driver-%{version}-%{release} is installed!";

%preun
QAT_SERVICE_PATH=/etc/init.d/
ECHO=/usr/bin/echo
RM=/usr/bin/rm
${ECHO} "Stopping QAT service"
if [ -e ${QAT_SERVICE_PATH}/qat_service ]; then
	until ${QAT_SERVICE_PATH}/qat_service shutdown
	do
		sleep 1
	done
	if [ -e /usr/bin/systemctl ]; then
		systemctl stop qat
		systemctl disable qat
		systemctl daemon-reload
	elif [ -e /sbin/chkconfig ]; then \
		chkconfig --del qat_service; \
	elif [ -e %{_sbindir}/update-rc.d ]; then \
		update-rc.d -f qat_service remove; \
	fi
fi
${RM} -rf /etc/udev/rules.d/00-qat.rules /etc/default/qat

%postun driver
depmod -a

%changelog
* Mon Sep 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.2
- Split kernel driver and library into separate packages

* Tue Aug 30 2022 Xin Zeng <xin.zeng@intel.com> - 0.9.4-00004.1
- Initial version of the package


